﻿using HeuristicLab.Common;
using HeuristicLab.Core;
using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
using HeuristicLab.Problems.DataAnalysis;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace HeuristicLab.Data {
  [Item("VariableRanges", "Represents the lower and upper bounds of the given variables.")]
  [StorableClass]
  public class VariableRanges : Item, IVariableRanges {
    private Dictionary<string, Interval> variableRanges;
    protected VariableRanges(VariableRanges original, Cloner cloner)
      : base(original, cloner) { }

    [StorableConstructor]
    protected VariableRanges(bool deserializing) : base(deserializing) { }

    public override IDeepCloneable Clone(Cloner cloner) {
      return new VariableRanges(this, cloner);
    }

    public VariableRanges() : base() { }

    public int Rows { get => throw new NotImplementedException(); set => throw new NotImplementedException(); }
    public int Columns { get => throw new NotImplementedException(); set => throw new NotImplementedException(); }
    public IEnumerable<string> ColumnNames { get => throw new NotImplementedException(); set => throw new NotImplementedException(); }
    public IEnumerable<string> RowNames { get => throw new NotImplementedException(); set => throw new NotImplementedException(); }
    public bool SortableView { get => throw new NotImplementedException(); set => throw new NotImplementedException(); }

    public bool ReadOnly => throw new NotImplementedException();

    public event EventHandler ColumnsChanged;
    public event EventHandler RowsChanged;
    public event EventHandler ColumnNamesChanged;
    public event EventHandler RowNamesChanged;
    public event EventHandler SortableViewChanged;
    public event EventHandler<EventArgs<int, int>> ItemChanged;
    public event EventHandler Reset;



    public Interval GetValue(string variable) {
      if (variableRanges.ContainsKey(variable))
        return variableRanges[variable];
      else
        throw new ArgumentException($"The variable: {variable} is not present.");
    }

    public bool SetValue(string variable, Interval value) {
      if (variableRanges.ContainsKey(variable)) {
        variableRanges[variable] = value;
        return true;
      }  else
        throw new ArgumentException($"The variable: {variable} is not present.");
    }

    public bool Validate(string value, out string errorMessage) {
      throw new NotImplementedException();
    }
  }
}
